package com.GreenDAO.relacion1_N;

import java.util.List;
import java.util.ArrayList;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.SqlUtils;
import de.greenrobot.dao.internal.DaoConfig;
import de.greenrobot.dao.query.Query;
import de.greenrobot.dao.query.QueryBuilder;

import com.GreenDAO.relacion1_N.Asignaturas;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table ASIGNATURAS.
*/
public class AsignaturasDao extends AbstractDao<Asignaturas, Long> {

    public static final String TABLENAME = "ASIGNATURAS";

    /**
     * Properties of entity Asignaturas.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Historia = new Property(1, boolean.class, "Historia", false, "HISTORIA");
        public final static Property Matemticas = new Property(2, boolean.class, "Matemticas", false, "MATEMTICAS");
        public final static Property Lenguaje = new Property(3, boolean.class, "Lenguaje", false, "LENGUAJE");
        public final static Property IdProfesor = new Property(4, Long.class, "idProfesor", false, "ID_PROFESOR");
    };

    private DaoSession daoSession;

    private Query<Asignaturas> profesores_AsignaturasQuery;

    public AsignaturasDao(DaoConfig config) {
        super(config);
    }
    
    public AsignaturasDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
        this.daoSession = daoSession;
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "'ASIGNATURAS' (" + //
                "'_id' INTEGER PRIMARY KEY ," + // 0: id
                "'HISTORIA' INTEGER NOT NULL ," + // 1: Historia
                "'MATEMTICAS' INTEGER NOT NULL ," + // 2: Matemticas
                "'LENGUAJE' INTEGER NOT NULL ," + // 3: Lenguaje
                "'ID_PROFESOR' INTEGER);"); // 4: idProfesor
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "'ASIGNATURAS'";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, Asignaturas entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
        stmt.bindLong(2, entity.getHistoria() ? 1l: 0l);
        stmt.bindLong(3, entity.getMatemticas() ? 1l: 0l);
        stmt.bindLong(4, entity.getLenguaje() ? 1l: 0l);
 
        Long idProfesor = entity.getIdProfesor();
        if (idProfesor != null) {
            stmt.bindLong(5, idProfesor);
        }
    }

    @Override
    protected void attachEntity(Asignaturas entity) {
        super.attachEntity(entity);
        entity.__setDaoSession(daoSession);
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public Asignaturas readEntity(Cursor cursor, int offset) {
        Asignaturas entity = new Asignaturas( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.getShort(offset + 1) != 0, // Historia
            cursor.getShort(offset + 2) != 0, // Matemticas
            cursor.getShort(offset + 3) != 0, // Lenguaje
            cursor.isNull(offset + 4) ? null : cursor.getLong(offset + 4) // idProfesor
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, Asignaturas entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setHistoria(cursor.getShort(offset + 1) != 0);
        entity.setMatemticas(cursor.getShort(offset + 2) != 0);
        entity.setLenguaje(cursor.getShort(offset + 3) != 0);
        entity.setIdProfesor(cursor.isNull(offset + 4) ? null : cursor.getLong(offset + 4));
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(Asignaturas entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(Asignaturas entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
    /** Internal query to resolve the "asignaturas" to-many relationship of Profesores. */
    public List<Asignaturas> _queryProfesores_Asignaturas(Long idProfesor) {
        synchronized (this) {
            if (profesores_AsignaturasQuery == null) {
                QueryBuilder<Asignaturas> queryBuilder = queryBuilder();
                queryBuilder.where(Properties.IdProfesor.eq(null));
                profesores_AsignaturasQuery = queryBuilder.build();
            }
        }
        Query<Asignaturas> query = profesores_AsignaturasQuery.forCurrentThread();
        query.setParameter(0, idProfesor);
        return query.list();
    }

    private String selectDeep;

    protected String getSelectDeep() {
        if (selectDeep == null) {
            StringBuilder builder = new StringBuilder("SELECT ");
            SqlUtils.appendColumns(builder, "T", getAllColumns());
            builder.append(',');
            SqlUtils.appendColumns(builder, "T0", daoSession.getProfesoresDao().getAllColumns());
            builder.append(" FROM ASIGNATURAS T");
            builder.append(" LEFT JOIN PROFESORES T0 ON T.'ID_PROFESOR'=T0.'_id'");
            builder.append(' ');
            selectDeep = builder.toString();
        }
        return selectDeep;
    }
    
    protected Asignaturas loadCurrentDeep(Cursor cursor, boolean lock) {
        Asignaturas entity = loadCurrent(cursor, 0, lock);
        int offset = getAllColumns().length;

        Profesores profesores = loadCurrentOther(daoSession.getProfesoresDao(), cursor, offset);
        entity.setProfesores(profesores);

        return entity;    
    }

    public Asignaturas loadDeep(Long key) {
        assertSinglePk();
        if (key == null) {
            return null;
        }

        StringBuilder builder = new StringBuilder(getSelectDeep());
        builder.append("WHERE ");
        SqlUtils.appendColumnsEqValue(builder, "T", getPkColumns());
        String sql = builder.toString();
        
        String[] keyArray = new String[] { key.toString() };
        Cursor cursor = db.rawQuery(sql, keyArray);
        
        try {
            boolean available = cursor.moveToFirst();
            if (!available) {
                return null;
            } else if (!cursor.isLast()) {
                throw new IllegalStateException("Expected unique result, but count was " + cursor.getCount());
            }
            return loadCurrentDeep(cursor, true);
        } finally {
            cursor.close();
        }
    }
    
    /** Reads all available rows from the given cursor and returns a list of new ImageTO objects. */
    public List<Asignaturas> loadAllDeepFromCursor(Cursor cursor) {
        int count = cursor.getCount();
        List<Asignaturas> list = new ArrayList<Asignaturas>(count);
        
        if (cursor.moveToFirst()) {
            if (identityScope != null) {
                identityScope.lock();
                identityScope.reserveRoom(count);
            }
            try {
                do {
                    list.add(loadCurrentDeep(cursor, false));
                } while (cursor.moveToNext());
            } finally {
                if (identityScope != null) {
                    identityScope.unlock();
                }
            }
        }
        return list;
    }
    
    protected List<Asignaturas> loadDeepAllAndCloseCursor(Cursor cursor) {
        try {
            return loadAllDeepFromCursor(cursor);
        } finally {
            cursor.close();
        }
    }
    

    /** A raw-style query where you can pass any WHERE clause and arguments. */
    public List<Asignaturas> queryDeep(String where, String... selectionArg) {
        Cursor cursor = db.rawQuery(getSelectDeep() + where, selectionArg);
        return loadDeepAllAndCloseCursor(cursor);
    }
 
}
